#include <mpi.h>
#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
  int rank;
  int P;
  char hname[MPI_MAX_PROCESSOR_NAME];
  int hname_len;
  int nthreads, tid;


  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &P);
  MPI_Get_processor_name(hname, &hname_len);

/* Fork a team of threads giving them their own copies of variables */
#pragma omp parallel private(nthreads, tid)
  {
    tid = omp_get_thread_num();
    nthreads = omp_get_num_threads();

    printf("Processor [%s] (rank %d/%d):  Thread %d/%d\n",
           hname, rank+1, P, tid+1, nthreads);
  }
  
  MPI_Finalize();
  return 0;
}
